﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace puzzle_zero_rows_columns4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Demonstrate the algorithm.
        private void btnGo_Click(object sender, EventArgs e)
        {
            // Load the array.
            int num_rows = txtInput.Lines.Length;
            int num_cols = txtInput.Lines[0].Replace(" ", "").Length;
            int[,] values = new int[num_rows, num_cols];
            for (int row = 0; row < num_rows; row++)
            {
                string line = txtInput.Lines[row].Replace(" ", "");
                for (int col = 0; col < num_cols; col++)
                {
                    values[row, col] = int.Parse(line.Substring(col, 1));
                }
            }

            // Zero the appropriate rows and columns.
            ZeroRowsAndColumns(values);

            // Display the result.
            string result = "";
            for (int row = 0; row < num_rows; row++)
            {
                for (int col = 0; col < num_cols; col++)
                {
                    result += values[row, col].ToString() + " ";
                }
                // Remove the final " " and add a new line.
                result = result.Substring(0, result.Length - 1) + "\r\n";
            }

            // Remove the final \r\n.
            result = result.Substring(0, result.Length - 2);
            txtResult.Text = result;
        }

        // Insert the algorithm here.
        private void ZeroRowsAndColumns(int[,] values)
        {
            // See if the first row should be zero.
            bool row0_is_zero = false;
            for (int col = 0; col <= values.GetUpperBound(1); col++)
            {
                if (values[0, col] == 0)
                {
                    row0_is_zero = true;
                    break;
                }
            }

            // See if the first column should be zero.
            bool col0_is_zero = false;
            for (int row = 0; row <= values.GetUpperBound(0); row++)
            {
                if (values[row, 0] == 0)
                {
                    col0_is_zero = true;
                    break;
                }
            }

            // Copy zeros into the first row and column.
            for (int row = 1; row <= values.GetUpperBound(0); row++)
            {
                for (int col = 1; col <= values.GetUpperBound(1); col++)
                {
                    if (values[row, col] == 0)
                    {
                        values[row, 0] = 0;
                        values[0, col] = 0;
                    }
                }
            }

            // Zero out the required rows.
            for (int row = 1; row <= values.GetUpperBound(0); row++)
            {
                if (values[row, 0] == 0)
                {
                    // Zero out this row.
                    for (int c = 1; c <= values.GetUpperBound(1); c++)
                    {
                        values[row, c] = 0;
                    }
                }
            }

            // Zero out the required columns.
            for (int col = 1; col <= values.GetUpperBound(1); col++)
            {
                if (values[0, col] == 0)
                {
                    // Zero out this column.
                    for (int r = 1; r <= values.GetUpperBound(0); r++)
                    {
                        values[r, col] = 0;
                    }
                }
            }

            // If the first row should be zero, zero it out.
            if (row0_is_zero)
            {
                for (int c = 0; c <= values.GetUpperBound(1); c++)
                {
                    values[0, c] = 0;
                }
            }

            // If the first column should be zero, zero it out.
            if (col0_is_zero)
            {
                for (int r = 0; r <= values.GetUpperBound(0); r++)
                {
                    values[r, 0] = 0;
                }
            }
        }
    }
}
